%global _lto_cflags %{nil}

Summary: OpenMP runtime library of LLVM
Name:    libomp
Version: 14.0.5
Release: 4%{?dist}
License: NCSA
URL:     http://openmp.llvm.org
Source0: https://github.com/llvm/llvm-project/releases/download/llvmorg-%{version}/openmp-%{version}.src.tar.xz
 
Patch3000: 0001-PATCH-openmp-CMake-Make-LIBOMP_HEADERS_INSTALL_PATH-.patch
 
BuildRequires: gcc gcc-c++ cmake ninja-build
BuildRequires: elfutils-libelf-devel libffi-devel
BuildRequires: perl perl-Data-Dumper perl-Encode 
BuildRequires: llvm-devel python3-lit
 
Requires: elfutils-libelf
 
%description
OpenMP subproject of LLVM.
 
%package devel
Summary:  OpenMP header files
Requires: clang-resource-filesystem = %{version}
 
%description devel
Development libraries and header files for using OpenMP.
 
%prep
%autosetup -n openmp-%{version}.src -p2
 
%build
 
%cmake	-GNinja \
	-DLIBOMP_INSTALL_ALIASES=OFF \
	-DLLVM_DIR=%{_libdir}/cmake/llvm \
	-DLIBOMP_HEADERS_INSTALL_PATH:PATH=%{_libdir}/clang/%{version}/include \
	-DOPENMP_LIBDIR_SUFFIX=64 \
	-DCMAKE_SKIP_RPATH:BOOL=ON

%cmake_build

%install
%cmake_install

rm -rf %{buildroot}%{_libdir}/libarcher_static.a

# not provides *.bc
rm -rf %{buildroot}%{_libdir}/libomptarget-*.bc

%check
# don't run testcase omp_detach_taskwait in aarch64
%ifarch aarch64
rm -f runtime/test/tasking/omp_detach_taskwait.c
%endif
%cmake_build --target check-openmp

%files
%license LICENSE.TXT
%{_libdir}/*.so

%files devel
%{_libdir}/clang/%{version}/include/*.h
%{_libdir}/cmake/openmp/FindOpenMPTarget.cmake
%{_includedir}/ompt-multiplex.h

%changelog
* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 14.0.5-4
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 14.0.5-3
- Rebuilt for OpenCloudOS Stream 23

* Tue Nov  8 2022 Xiaojie Chen <jackxjchen@tencent.com> - 14.0.5-2
- Don't run testcase omp_detach_taskwait in aarch64

* Fri Jul 29 2022 Wang Zhe <bessiewang@tencent.com> - 14.0.5-1
- initial build
